"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppLayout = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const lucide_react_native_1 = require("lucide-react-native");
const react_native_1 = require("react-native");
const Modals_1 = require("@procyon/components/Modal/Modals");
const Toaster_1 = require("@procyon/components/Toaster");
const useScreenDimensions_1 = require("@procyon/hooks/useScreenDimensions");
const mq_1 = require("@procyon/styles/mq");
const AppLayout = ({ children, Footer = react_native_1.View, TopNav, Logo, UserNav, SideNav, toasterPosition = 'topRight', }) => {
    const enabledSideNav = !!SideNav;
    const enabledTopNav = !!TopNav || !!UserNav;
    (0, useScreenDimensions_1.useScreenDimensions)();
    const [sideCollapsed, setSideCollapsed] = (0, react_1.useState)(false);
    const [topCollapsed, setTopCollapsed] = (0, react_1.useState)(true);
    const toggleSide = () => {
        setSideCollapsed(!sideCollapsed);
    };
    const toggleTop = () => {
        setTopCollapsed(!topCollapsed);
    };
    return (react_1.default.createElement(AppLayoutContainer, null,
        enabledTopNav && (react_1.default.createElement(AppLayoutTopNav, { onPress: toggleTop },
            react_1.default.createElement(AppLayoutTopLeftSide, { placeholder: !Logo },
                react_1.default.createElement(AppLayoutLogo, null, Logo !== null && Logo !== void 0 ? Logo : react_1.default.createElement(react_native_1.View, null)),
                react_1.default.createElement(AppLayoutMenuToggle, { style: {
                        marginBottom: 2,
                    }, strokeWidth: 1 })),
            react_1.default.createElement(AppLayoutNavSection, { visible: !topCollapsed, direction: "row", justifyContent: "flex-start" }, TopNav === null || TopNav === void 0 ? void 0 : TopNav.map((Nav, i) => react_1.default.createElement(Nav, { key: i }))),
            react_1.default.createElement(AppLayoutNavSection, { visible: !topCollapsed, direction: "row", justifyContent: "flex-end" }, UserNav === null || UserNav === void 0 ? void 0 : UserNav.map((Nav, i) => react_1.default.createElement(Nav, { key: i }))))),
        react_1.default.createElement(AppLayoutContent, null,
            enabledSideNav && (react_1.default.createElement(AppLayoutSideNav, { onPress: toggleSide },
                react_1.default.createElement(AppLayoutMenuToggle, { style: { minWidth: 30 }, strokeWidth: 1 }),
                react_1.default.createElement(AppLayoutNavSection, { visible: sideCollapsed, direction: "column", justifyContent: "center" }, SideNav === null || SideNav === void 0 ? void 0 : SideNav.map((Nav, i) => react_1.default.createElement(Nav, { side: true, key: i }))))),
            react_1.default.createElement(AppLayoutPage, null, children)),
        react_1.default.createElement(Footer, null),
        react_1.default.createElement(Modals_1.Modals, null),
        react_1.default.createElement(Toaster_1.Toasters, { position: toasterPosition })));
};
exports.AppLayout = AppLayout;
const AppLayoutContainer = native_1.default.View(({ theme }) => {
    return {
        backgroundColor: theme.palette.background.main,
    };
});
const AppLayoutNavSection = native_1.default.View(({ theme, direction, visible, justifyContent }) => {
    const br = (0, mq_1.mQ)(theme);
    return Object.assign({ display: 'flex', flexDirection: direction, columnGap: 4, rowGap: 4 }, br.xs(Object.assign({ marginTop: theme.spacing.sm, flexWrap: 'wrap', flex: 1, justifyContent: justifyContent }, (visible
        ? {}
        : {
            display: 'none',
        }))));
});
const AppLayoutTopNav = native_1.default.Pressable(({ theme }) => {
    const br = (0, mq_1.mQ)(theme);
    return Object.assign({ backgroundColor: theme.palette.primary.light, display: 'flex', flexDirection: 'row', justifyContent: 'space-between', columnGap: 4, alignItems: 'center', padding: theme.spacing.sm }, br.xs({
        flexDirection: 'column',
        alignItems: 'stretch',
    }));
});
const AppLayoutTopLeftSide = native_1.default.View(({ theme, placeholder }) => {
    const br = (0, mq_1.mQ)(theme);
    return Object.assign(Object.assign({}, (placeholder && {
        display: 'none',
    })), br.xs({
        display: 'flex',
        flexDirection: 'row',
        justifyContent: 'space-between',
        alignItems: 'center',
    }));
});
const AppLayoutLogo = native_1.default.Text(({ theme }) => {
    return {
        color: theme.palette.primary.dark,
        fontFamily: theme.fontFamily,
        fontSize: theme.fontSize.xl,
    };
});
const AppLayoutMenuToggle = (0, native_1.default)(lucide_react_native_1.MenuIcon)(({ theme }) => {
    const br = (0, mq_1.mQ)(theme);
    return Object.assign({ display: 'none' }, br.xs({
        display: 'flex',
    }));
});
const AppLayoutContent = native_1.default.View(({ theme }) => {
    const br = (0, mq_1.mQ)(theme);
    return Object.assign({ display: 'flex', flexDirection: 'row-reverse', gap: 4, marginTop: theme.spacing.md }, br.xs({
        flexDirection: 'column',
        marginTop: theme.spacing.sm,
    }));
});
const AppLayoutSideNav = native_1.default.Pressable(({ theme }) => {
    const br = (0, mq_1.mQ)(theme);
    return Object.assign({ width: 150, borderRadius: theme.rounded.small, backgroundColor: theme.palette.secondary.light, display: 'flex', flexDirection: 'column', justifyContent: 'space-between', rowGap: 4, padding: theme.spacing.sm, marginRight: 2 }, br.xs({
        width: 'auto',
        flexDirection: 'row',
        flexWrap: 'wrap',
        marginHorizontal: theme.spacing.md,
    }));
});
const AppLayoutPage = native_1.default.View(({ theme }) => {
    return {
        padding: theme.spacing.md,
        flex: 1,
    };
});
