"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dropdown = void 0;
const react_1 = __importStar(require("react"));
const react_2 = require("@emotion/react");
const lucide_react_native_1 = require("lucide-react-native");
const react_native_1 = require("react-native");
const react_native_reanimated_1 = require("react-native-reanimated");
const tiny_invariant_1 = __importDefault(require("tiny-invariant"));
const Button_1 = require("@procyon/components/Button");
const ButtonGroup_1 = require("@procyon/components/ButtonGroup");
const context_1 = require("@procyon/components/Modal/context");
const debounce_1 = require("@procyon/utils/debounce");
const Dropdown = ({ Buttons, MainButton, size = 'md', name, }) => {
    const theme = (0, react_2.useTheme)();
    const viewRef = (0, react_1.useRef)(null);
    const [openModal, closeModal, { opened }] = (0, context_1.useModal)(name, {
        Component: ({ rootStyle }) => {
            return (react_1.default.createElement(react_native_1.View, { style: [rootStyle] }, Buttons && (react_1.default.createElement(Buttons, Object.assign({}, (size ? { size } : {}), { fullWidth: true,
                style: {
                    container: {
                        marginVertical: 3,
                    },
                }, onClick: (0, debounce_1.debounceAfter)(() => handleClose(), 100) })))));
        },
    });
    const handleClose = () => {
        closeModal();
    };
    const handleOpenButtons = () => {
        if (opened.includes(name)) {
            closeModal();
            return;
        }
        (0, react_native_reanimated_1.runOnUI)(() => {
            if (!(viewRef === null || viewRef === void 0 ? void 0 : viewRef.current)) {
                (0, tiny_invariant_1.default)('Unable to measure element for obtain position!');
                return null;
            }
            viewRef.current.measure((x, y, width, height, pageX, pageY) => {
                (0, react_native_reanimated_1.runOnJS)(openModal)({
                    props: {
                        rootStyle: {
                            position: 'absolute',
                            width: width,
                            top: pageY + theme.spacing[size] * 2 + theme.fontSize[size] * 2,
                            left: pageX,
                            zIndex: 7,
                        },
                    },
                    style: {
                        overflow: {
                            backgroundColor: 'transparent',
                        },
                    },
                });
            });
        })();
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(ButtonGroup_1.ButtonGroup, { ref: viewRef },
            MainButton,
            Buttons && (react_1.default.createElement(Button_1.Button, Object.assign({ style: { container: { minWidth: 40, maxWidth: 50 } }, onClick: () => handleOpenButtons() }, (size ? { size } : {})), opened.includes(name) ? react_1.default.createElement(lucide_react_native_1.ChevronUpIcon, null) : react_1.default.createElement(lucide_react_native_1.ChevronDownIcon, null)))),
        react_1.default.createElement(react_native_1.View, null,
            react_1.default.createElement(react_native_1.Text, null, "ahoj"))));
};
exports.Dropdown = Dropdown;
